{$N+,E+}
{ GX2 screen buffering demo
  Shows, how to use the buffering object and how to access the timer }
uses grafx2,gx_glob,gx_utils,timebase,crt,gx_font;
var
  line    : tpoint;
  linc    : tpoint;
  screen  : tgxscreen;
  buffer  : tbuffer;
  timer   : tztimer;
  count   : longint;
  fps     : string[10];
  ch      : char;
  s       : string;

begin
  if not screen.init(640,480,clhi,mdauto) then
    writeln(gxerror,'Error while initializing video mode');
  if not buffer.init(screen,2,bfauto) then
    writeln(gxerror,'Error while initializing screen buffer (probably too few memory)');
  s := 'Automatic buffering mode';
  timer.init;
  linc.x := 1;
  linc.y := 1;

  timer.start;
  count := 0;
  repeat
    if timer.lap >= 1000000 then begin
      timer.stop;
      timer.start;
      fps := inttostr(count);
      count := 0;
    end;
    buffer.screen^.clear;
    buffer.screen^.line(0,line.y,screen.maxx,screen.maxy-line.y,
                        screen.rgb(255,128,0),lnantialias);
    buffer.screen^.line(line.x,0,screen.maxx-line.x,screen.maxy,
                        screen.rgb(255,0,0),lnantialias);

    sysfont.write(buffer.screen^,screen.maxx-70,10,fps+' fps',screen.rgb(255,255,255));
    sysfont.write(buffer.screen^,10,10,screen.getversionstring,screen.rgb(255,255,255));

    sysfont.write(buffer.screen^,10,30,'Available keys:',screen.rgb(255,255,255));
    sysfont.write(buffer.screen^,10,40,'A: Automatic flipping',screen.rgb(255,255,255));
    sysfont.write(buffer.screen^,10,50,'M: Memory flipping',screen.rgb(255,255,255));
    sysfont.write(buffer.screen^,10,60,'C: Combined screen/memory flipping',screen.rgb(255,255,255));

    sysfont.write(buffer.screen^,10,80,'Current buffering mode:',screen.rgb(255,255,255));
    sysfont.write(buffer.screen^,10,90,s,screen.rgb(255,255,255));

    buffer.screen^.rect(0,0,screen.maxx,screen.maxy,screen.rgb(255,255,255),lndefault);
    inc(line.x,linc.x);
    inc(line.y,linc.y);
    if (line.x >= screen.maxx)or(line.x <= 0) then linc.x := -linc.x;
    if (line.y >= screen.maxy)or(line.y <= 0) then linc.y := -linc.y;
    buffer.flip;
    inc(count);
    if keypressed then begin
      ch := readkey;
      case ch of
        'a','A' : begin
                    s := 'Automatic buffering mode (with retrace wait)';
                    buffer.done;
                    buffer.init(screen,2,bfauto);
                  end;
        'm','M' : begin
                    s := 'Memory buffering mode (without retrace wait)';
                    buffer.done;
                    buffer.init(screen,2,bfmemonly);
                  end;
        'c','C' : begin
                    s := 'Combined buffering (with retrace wait)';
                    buffer.done;
                    buffer.init(screen,2,bfmem2scr);
                  end;
      end;
    end else ch := #1;
  until (ch = #27);

  timer.done;
  buffer.done;
  screen.close;
  while keypressed do readkey;
end.