{
 This particle system is based on an article by the German computer magazine
 PC Magazin. I have rewritten it in Pascal, of course for GrafX 2 - the best
 graphics library for Borland Pascal 7.0 by Stefan Goehler.
 You may use this code whereever you want, but please credit me.
 Comments and suggestions to som@bigfoot.de .
  Alexander Oster - and don't forget: DOS RULEZ
}

uses crt, grafx2, gx_glob, NewFrontier, Timebase;

const
MaxParticles=10000;
MaxQueue=32;

{Offsets}
 OLife=0; Ox=4; Oy=8; Odx=12; Ody=16; Oddx=20; Oddy=24;

type

TParticle=record
 life     : LongInt;
 x,y      : LongInt;
 dx,dy    : LongInt;
 ddx, ddy : LongInt;
end;

TExplosion_Queue=record
 x,y,density,Expltype: LongInt;
 time:comp;
 Used: Boolean;
end;

TIntArray=array[0..MaxParticles-1] of Integer;
TQueueArray=array[0..MaxQueue-1] of TExplosion_Queue;
TByteArray=array[0..255] of Byte;

Var
 Explosion_Particle: TSelector;
 Free_Explosion_Particle: ^TIntArray;
 Index_Free_Explosion: Integer;
 explosion_particles: Integer;
 Explosion_Queue: ^TQueueArray;
 Screen:TGXscreen;
 vScreen:TGXmem;
 vImage:TImage;
 vMode:Pointer;
 timer:TzTimer;

function rand:Integer;
begin
 rand:=Random(32768);
end;

function rand1:Single;
begin
 rand1:=rand / 16384 / 4 -1;
end;

function ReadParticle(Nr,Offset:LongInt): Longint;
begin
 ReadParticle:=ReadMem32L(Ptr48(Explosion_Particle,Nr*sizeof(TParticle)+Offset));
end;

procedure WriteParticle(Nr,Offset:LongInt; Value: Longint);
begin
 WriteMem32L(Ptr48(Explosion_Particle,Nr*sizeof(TParticle)+Offset),Value);
end;

procedure IncParticle(Nr,Offset:LongInt; Value: Longint);
begin
 IncMem32L(Ptr48(Explosion_Particle,Nr*sizeof(TParticle)+Offset),Value);
end;

procedure DecParticle(Nr,Offset:LongInt; Value: Longint);
begin
 DecMem32L(Ptr48(Explosion_Particle,Nr*sizeof(TParticle)+Offset),Value);
end;


procedure InitParticleSystem;
Var
 i:LongInt;
 rgb: trgb;
begin
 explosion_particles:=0;
 index_free_explosion:=MaxParticles;
 New(Free_Explosion_Particle);
 New(Explosion_Queue);
 GetMem32(Explosion_Particle, MaxParticles * sizeof(TParticle));
 FillByte(Ptr48(Explosion_Particle,0),MaxParticles * sizeof(TParticle),0);
 For i:=0 to MaxParticles-1 do Free_Explosion_Particle^[i]:=i;
 For i:=0 to MaxQueue-1 do Explosion_Queue^[i].Used:=False;
 vMode:=@vScreen.Mode;
end;

procedure FreeParticleSystem;
begin
 Dispose(Free_Explosion_Particle);
 Dispose(Explosion_Queue);
 FreeMem32(Explosion_Particle);
end;

procedure AddExplosion(x,y,density,Expltype:LongInt);
Var
 Phase, Richtung1, Richtung2, Speed1, Speed2: Single;
 d,n, LifeFactor:Integer;
begin
 if explType=1 then phase:=rand/32768*8 else phase :=0;
 if explType=2 then LifeFactor:=14 else LifeFactor:=16;
 for d:=0 to density-1 do begin
  if index_free_explosion <=0 then exit;
  dec(index_free_explosion);
  n:=free_explosion_particle^[index_free_explosion];
  richtung1:=rand/32768*2*pi;
  speed1:=rand / 32768.0 * 0.75 + sin( phase ) * 3.0;
  richtung2:=rand/32768*2*pi;
  speed2:=rand / 32768.0 * 0.015 + sin( phase ) * 0.06;
  WriteParticle(n,Ox, ( x shl 16 ) + ( rand - 16384 ) * 32);
  WriteParticle(n,Oy, ( y shl 16 ) + ( rand - 16384 ) * 32);
  WriteParticle(n,Odx,   Trunc( sin( richtung1 ) * speed1 * 65536.0));
  WriteParticle(n,Ody,   Trunc( cos( richtung1 ) * speed1 * 65536.0));
  WriteParticle(n,Oddx,  Trunc( sin( richtung2 ) * speed2 * 65536.0));
  WriteParticle(n,Oddy,  Trunc( cos( richtung2 ) * speed2 * 65536.0));
  WriteParticle(n,Olife, Trunc( rand / 32768 * LifeFactor + 8 * LifeFactor ) shl 16);
  inc(explosion_particles);
 end;
end;

procedure BigShipExplosion(x,y:Integer);
var
 n,i: Integer;
 Time: comp;
begin
 time:=timer.lap;
 For n:=0 to 7 do begin
  i:=0;
  while (i< MaxQueue) and (explosion_queue^[i].used) do inc(i);
  if i=maxqueue then exit;
  explosion_queue^[i].used:=true;
  explosion_queue^[i].x:=x + trunc(rand1 * 16);
  explosion_queue^[i].y:=y + trunc(rand1 * 16);
  explosion_queue^[i].density:=400+400-n*50;
  explosion_queue^[i].expltype:=1;
  explosion_queue^[i].time:=time+n*364000;
 end;
end;

procedure NormalExplosion(x,y:Integer);
var
 n,i: Integer;
 Time: comp;
begin
 time:=timer.lap;
 For n:=0 to 1 do begin
  i:=0;
  while (i< MaxQueue) and (explosion_queue^[i].used) do inc(i);
  if i=maxqueue then exit;
  explosion_queue^[i].used:=true;
  explosion_queue^[i].x:=x + trunc(rand1 * 16);
  explosion_queue^[i].y:=y + trunc(rand1 * 16);
  explosion_queue^[i].density:=450+n*100;
  explosion_queue^[i].expltype:=2;
  explosion_queue^[i].time:=time+n*364000;
 end;
end;

procedure RocketExplosion(x,y:Integer);
var
 Time: comp;
 i: Integer;
begin
 time:=timer.lap;
  i:=0;
  while (i< MaxQueue) and (explosion_queue^[i].used) do inc(i);
  if i=maxqueue then exit;
  explosion_queue^[i].used:=true;
  explosion_queue^[i].x:=x;
  explosion_queue^[i].y:=y;
  explosion_queue^[i].density:=300;
  explosion_queue^[i].expltype:=0;
  explosion_queue^[i].time:=timer.lap;
end;

procedure HandleExplosion;
var
 time:comp;
 i:Integer;
begin
 time:=timer.lap;
 for i:=0 to MaxQueue-1 do if explosion_queue^[i].used and (explosion_queue^[i].time <= time) then begin
  explosion_queue^[i].used:=false;
  AddExplosion(explosion_queue^[i].x,explosion_queue^[i].y,explosion_queue^[i].density, explosion_queue^[i].expltype);
 end;
end;

procedure additive;
assembler; asm
 push bx
 shr ax,1
 and ax, 07BEFh
 shr bx,1
 and bx, 07BEFh
 add ax, bx
 shl ax,1
 db $0F, $92, $C3 {setc bl}
 test ax, 020h
 jz @1
  or ax,31
 @1:
 test ax, 0800h
 jz @2
  or ax,2016
 @2:
 or bl,bl
 jz @3
  or ax,0F800h
 @3:
 pop bx
end;

procedure addpixel(x,y,Color:LongInt);assembler;
asm
 db $66; mov ax, word ptr y                     { mov eax, y }
 db $66; mov bx, word ptr vImage.bpl            { mov ebx, vImage.bpl }
 db $66; mul bx                                 { mul ebx }
 db $66; mov di, ax                             { mov edi, eax }
 db $66; add di, word ptr x                     { add edi, x }
 db $66; add di, word ptr x                     { add edi, x }
 mov ax, word ptr Color
 db $26, $67; mov bx, [bx]                      { mov bx, es:[edi] }
 call additive
 db $26,$67; mov [bx],ax                        { mov  [es:edi], ax }
 db $66, $83, $C7, $02                          { add edi , 2 }
 db $66; cmp di, word ptr VImage.size           { cmp edi, VImage.Size }
 jge @end
 mov ax, word ptr Color
 db $26, $67; mov bx, [bx]                      { mov bx, es:[edi] }
 call additive
 db $26,$67; mov [bx],ax                        { mov  [es:edi], ax }
 db $66; add di, word ptr vImage.bpl            { add edi , vImage.bpl }
 db $66; cmp di, word ptr VImage.size           { cmp edi, VImage.Size }
 jge @end
 mov ax, word ptr Color
 db $26, $67; mov bx, [bx]                      { mov bx, es:[edi] }
 call additive
 db $26,$67; mov [bx],ax                        { mov  [es:edi], ax }
 db $66, $83, $EF, $02                          { sub edi , 2 }
 mov ax, word ptr Color
 db $26, $67; mov bx, [bx]                      { mov bx, es:[edi] }
 call additive
 db $26,$67; mov [bx],ax                        { mov  [es:edi], ax }
 @end:
end;


procedure DrawExplosion;assembler;
Var
 i :Word;
 asm
  push vImage.Data
  pop es
  push word ptr free_explosion_particle +2
  db $0F, $A9                                                { pop gs }
  db $66; xor si, si                                         { xor esi,esi }
  push explosion_particle
  db $0F, $A1                                                { pop fs }
  mov cx, MaxParticles
  mov i,0
  @start:
  push cx
  db $66, $64, $67, $83, $3E, $00                            { cmp dword ptr fs:[esi], 00 }
  jng @label1
   db $64, $67, $66, $8B, $46, 12                            { mov eax, fs:[esi+12] }
   db $64, $67, $66, $01, $46, 04                            { add fs:[esi+04],eax }
   db $64, $67, $66, $8B, $46, 16                            { mov eax, fs:[esi+16] }
   db $64, $67, $66, $01, $46, 08                            { add fs:[esi+08],eax }
   db $64, $67, $66, $8B, $46, 20                            { mov eax, fs:[esi+20] }
   db $64, $67, $66, $01, $46, 12                            { add fs:[esi+12],eax }
   db $64, $67, $66, $8B, $46, 24                            { mov eax, fs:[esi+24] }
   db $64, $67, $66, $01, $46, 16                            { add fs:[esi+16],eax }
   db $64, $67, $66, $8B, $4E, $04                           { mov ecx, fs:[esi+4] }
   db $66; add cx, 0FFFFh; dw 0                              { add ecx, 0FFFFh }
   db $66; shr cx, 16                                        { shr ecx, 16 }
   db $64, $67, $66, $8B, $56, $08                           { mov edx, fs:[esi+8] }
   db $66; add dx, 0FFFFh; dw 0                              { add edx, 0FFFFh }
   db $66; shr dx, 16                                        { shr edx, 16 }
   cmp cx, word ptr vImage.sizex
   jge @dead
   cmp cx, 0
   jl @dead
   cmp dx, word ptr vImage.sizey
   jge @dead
   cmp dx, 0
   js @dead
   db $66, $64, $67, $81, $2E, $FF, $FF, $00, $00            { sub dword ptr fs:[esi], 0FFFFh }
   js @dead
   jmp @notdead
   @dead:
    db $66, $64, $67, $C7, $06, $00, $00, $00, $00           { mov dword ptr fs:[esi],0 }
    mov bx, index_free_explosion
    shl bx,1
    mov ax, i
    db $65; mov [bx], ax                                     { mov gs:[bx], ax }
    inc index_free_explosion
    jmp @label1
   @notdead:
    push cx
    push dx
    db $64, $67, $66, $8B, $06                               { mov eax, fs:[esi] }
    db $66; add ax, 0FFFFh; dw 0                             { add eax, 0FFFFh }
    db $66; shr ax, 16                                       { shr eax, 16 }
    mov bx, 16
    mov cx, 16
    mov dx, 16
    add dx, ax
    cmp ax, 32
    jng @1
    add cx,ax
    sub cx,16
    jmp @2
    @1:
    push ax
    shr ax, 1
    add cx,ax
    pop ax
    @2:
    cmp ax, 48
    jng @3
    add bx,ax
    sub bx,48
    jmp @4
    @3:
    push ax
    shr ax,2
    add bx,ax
    pop ax
    @4:
    mov   al,bl
    mov   ah,cl
    shr   ah,2
    mov   bl,dl
    shr   ax,3
    and   bl,11111000b
    or    ah,bl
    pop dx
    pop cx
    push 0
    push cx
    push 0
    push dx
    push 0
    push ax
    call addpixel
   @label1:
   pop cx
   db $66, $83, $C6, 28                                      { add esi, 28 }
   inc i
   dec cx
   jz @5
   jmp @start
   @5:
  end;

var
 t:comp;
begin
 Timer.Init;
 Timer.Start;
 writeln(memavail);
 Randomize;
 if not Screen.Init(640,480,16,mdauto) then
   Writeln(gxerror,'Error while initializing video mode');

 OpenImage(vImage,640,480,16,0,imdefault);
 vScreen.Init (vImage);
 InitParticleSystem;
 BigShipExplosion(160,120);
 RocketExplosion(300,200);
 NormalExplosion(40,40);
 t:=Timer.Lap;
 repeat
  if t <= Timer.Lap then begin
  t:=Timer.Lap+50000;
  vScreen.Clear;
  HandleExplosion;
  DrawExplosion;
  Screen.Draw(0,0,vImage,drdefault);
  end;
 until keypressed;
 Timer.Done;
 vScreen.Close;
 CloseImage(vImage);
 Screen.Close;
 FreeParticleSystem;
 writeln(memavail);
 While Keypressed do Readkey;
end.