{-$DEFINE Debug}
{$A+,B-,E-,F-,G+,I-,N-,O+,P-,Q-,R-,S-,T-,V-,X+,Y-}
{$IFDEF Debug}{$D+,L+,Y+}{$ENDIF}
unit GifLib;
{****************************************************************************
 * Author            : Maarten vd Zwaart, The Netherlands                   *
 * Version           : 1.0                                                  *
 ******                                                                     *
 * my e-mail address : mrtnzwaart@freemail.nl                               *
 ****** VERSION HISTORY *****************************************************
 * Version 1.0  *First public release with GrafX2b1                         *
 *              -Both the gif loader and saver do not handle animations     *
 *               very well yet                                              *
 *              -Especially the gif saver isn't very well optimized         &
 ****************************************************************************}
interface
uses NewFrontier, Grafx2, Gx_Glob, Gx_Col, Gx_Image, stream32, objects;

function LoadGif(var stream : tstream32; var Image: TImage; UseBPP, Flags: LongInt): Word;
function SaveGif(var stream : tstream32; Image: TImage): Word;

implementation

type
  TGifH = Record
    Sig: Array[0..2] Of Char;
    Ver: Array[0..2] Of Char;
    Width, Height: Word;
    PackedField: Byte;
    BGColor: Byte;
    AspectRatio: Byte
  end;

  TImageDescriptor = Record
    XP, YP, XS, YS: Word;
    PackedField: Byte
  end;

  TGraphicControlExtension = Record
    BlockSize: Byte;
    PackedField: Byte;
    DelayTime: integer;
    TransColor: Byte
  end;

function AddPtr(P: Pointer48; N: LongInt): Pointer48; assembler;
asm
  mov dx, p.word + 4
  mov bx, p.word + 2
  mov ax, p.word
  add ax, n.word
  adc bx, n.word + 2
end;
{$IFDEF Debug}
procedure WriteToLog(S: String);
var
  F: Text;
begin
  Assign(F, 'debug.log');
{ this does not seem to work well, at least not under Windows
  Append(F);
  if IOResult <> 0 then
    Rewrite(F);
}
  repeat
    Append(F)
  until IOResult = 0;
  WriteLn(F, S);
  WriteLn(S);
  Close(F)
end;
{$ENDIF}
function LoadGif(var stream : tstream32; var Image: TImage; UseBPP, Flags: LongInt): Word;
var
{  F: File;}
  Size, Pos: LongInt;
  P, P2: Pointer48;
  Sel: TSelector;
  GifH: TGifH;
  HasGCT: Boolean;
  ColorRes: Byte;
  GCTColorSort: Boolean;
  GCTSize: Byte;
  NumImg: Integer;
  B: Integer;
  ImageDescriptor : TImageDescriptor;
  GCExt: TGraphicControlExtension;
  IsTrans, CurTrans: Boolean;
  TransColor: Byte;
  IsLCT, CurLCT: Boolean;
  UserInput: Boolean;
  Interlaced, LCTColorSort: Boolean;
  LCTSize: Byte;
  DispMethod, LastDisp: Byte;
  StringSuffix: Array[0..4095] of Byte;
  StringPrefix: Array[0..4095] of Word;
  StringBegin: Array[0..4095] of Byte;
  StringTemp: Array[0..4095] of Byte;
  LZWData: TSelector;
  LZWSize: LongInt;
  LZWPos: LongInt;
  LZWMin: Byte;
  LZWCodeS: Byte;
  LZWBitPos: Byte;
  LZWCodeMask: Word;
  CurCode, OldCode: Word;
  Elements: Word;
  X, Y, IncY: Integer;
  InterPass: Byte;
  Error: Integer;
  ImgNum: Integer;

  ConvertData: TCnvProc;
  CnvTmp: PCnvProc;

  TempBuf: Pointer;
  mainpal: Pointer;

  function GetCode: Word;
  begin
    GetCode := ReadMem32L(Ptr48(LZWData, LZWPos)) shr LZWBitPos and LZWCodeMask;
    Inc(LZWBitPos, LZWCodeS);
    Inc(LZWPos, LZWBitPos div 8);
    LZWBitPos := LZWBitPos mod 8
  end;

  procedure OutputStr(Code: Word);
{$IFDEF Debug}
  var
    F: File;
{$ENDIF}
  begin
    B := 0;
    repeat
      Inc(B);
      StringTemp[B] := StringSuffix[Code];
      Code := StringPrefix[Code]
    until Code = $FFFF;
    while (B > 0) and (Y <> -1) do
    begin
      Move(StringTemp[B], Pointer(LongInt(TempBuf) + X)^, 1);
      Inc(X);
      if X = ImageDescriptor.XS + ImageDescriptor.XP then
      begin
{$IFDEF Debug}
        Assign(F, 'image.dat');
        if Y = 0 then Rewrite(F, 1)
        else
        begin
          Reset(F, 1);
          Seek(F, FileSize(F))
        end;
        BlockWrite(F, TempBuf^, Image.BPL);
        Close(F);
{$ENDIF}
        ConvertData(FarPtr(TempBuf), Ptr48(Image.Data, Image.ImageStart + Y * Image.BPL), Image.SizeX);
        X := ImageDescriptor.XP;
        Inc(Y, IncY)
      end;
      if Y >= ImageDescriptor.YS + ImageDescriptor.YP then
      begin
        Inc(InterPass);
        case InterPass of
          1: Y := ImageDescriptor.YP + 4;
          2:
          begin
            Y := ImageDescriptor.YP + 2;
            IncY := 4
          end;
          3:
          begin
            Y := ImageDescriptor.YP + 1;
            IncY := 2
          end
        else
          Y := -1
        end
      end;
      Dec(B)
    end
  end;

begin
  LoadGif := ErrFileError;
  if (stream.status <> stok) then exit;
{  if (Image.ID = IdImage) and (Image.Data <> 0) then CloseImage(Image);}
{  Assign(F, Name);
  Reset(F, 1);
  if IOResult <> 0 then Exit;}

  Size := {FileSize(F)}stream.getsize;
  GetMem32(Sel, Size);
  LoadGif := ErrNoMem;
  if Sel = 0 then Exit;
  P := Ptr48(Sel, 0);
  pos := stream.Read32(P, Size);
  stream.done;
  LoadGif := ErrFileError;
  if Pos < Size then
  begin
    FreeMem32(Sel);
    Exit;
  end;
  Move32(P, FarPtr(@GifH), SizeOf(TGifH));
  P := AddPtr(P, SizeOf(TGifH));

  HasGCT := GifH.PackedField shr 7 = 1;
  ColorRes := GifH.PackedField shr 4 and 7 + 1;
  GCTColorSort := GifH.PackedField shr 3 and 1 = 1;
  GCTSize := GifH.PackedField and 7 + 1;

  P2 := P;
  if HasGCT then
    P2 := AddPtr(P2, 3 shl GCTSize);

  NumImg := 0;
  IsLCT := False;

  LoadGif := ErrFalseFormat;

  repeat
    B := ReadMem32B(P2);
    P2 := AddPtr(P2, 1);
{$IFDEF Debug}
    WriteLn(B: 3, NumImg: 5);
{$ENDIF}
    case B of
      $3B: Break;
      $2C:
      begin
        Move2(P2, FarPtr(@ImageDescriptor), SizeOf(TImageDescriptor));
        P2 := AddPtr(P2, SizeOf(TImageDescriptor));
        CurLCT := ImageDescriptor.PackedField shr 7 = 1;
        Interlaced := ImageDescriptor.PackedField shr 6 and 1 = 1;
        LCTColorSort := ImageDescriptor.PackedField shr 5 and 1 = 1;
        LCTSize := ImageDescriptor.PackedField and 7 + 1;
        if CurLCT then
        begin
          IsLCT := True;
          P2 := AddPtr(P2, 3 shl LCTSize)
        end;
        P2 := AddPtr(P2, 1);
        repeat
          B := ReadMem32B(P2);
          P2 := AddPtr(P2, B + 1)
        until B = 0;
        Inc(NumImg)
      end;
      $21:
      begin
        B := ReadMem32B(P2);
{$IFDEF Debug}
        WriteLn(B: 5);
{$ENDIF}
        P2 := AddPtr(P2, 1);
        case B of
          $F9:
          begin
            Move2(P2, FarPtr(@GCExt), SizeOf(TGraphicControlExtension));
            P2 := AddPtr(P2, GCExt.BlockSize + 2)
          end;
          $FE:
          repeat
            B := ReadMem32B(P2);
            P2 := AddPtr(P2, B + 1)
          until B = 0;
          $01:
          begin {text block}
            FreeMem32(Sel);
            Exit
          end;{not supported yet}
          $FF:
          begin
            P2 := AddPtr(P2, 12);
            repeat
              B := ReadMem32B(P2);
              P2 := AddPtr(P2, B + 1)
            until B = 0
          end
        else
          FreeMem32(Sel);
          Exit
        end
      end
    else
      FreeMem32(Sel);
      Exit
    end
  until False;

  CnvTmp  := PrepareImage_Cnv(Image, GifH.Width, GifH.Height, 8, UseBPP, NumImg, Flags, CnvImgMd);
  LoadGif := ErrFalseBpp;
  if CnvTmp = Nil then
  begin
    FreeMem32(Sel);
    Exit
  end;
  ConvertData := TCnvProc(CnvTmp);

  IsTrans := False;
  CurTrans := False;
  if HasGCT then
  begin
    getmem(mainpal,1024);
    Pal_24to32(P, farptr(mainpal), (1) shl GCTSize);
    Pal_24to32(P, cnvpal, (1) shl GCTSize);
    if Image.BPP > 8 then
    begin
      case Image.BPP of
        15: Pal_32to15(farptr(mainpal), CnvPal, 1 shl GCTSize);
        16: Pal_32to16(farptr(mainpal), CnvPal, 1 shl GCTSize)
      end
    end
    else
      Move2(cnvpal, Ptr48(Image.Data, Image.PalStart), 4 shl GCTSize);

    P := AddPtr(P, 3 shl GCTSize);
  end;

  Error := ErrNoError;

  LastDisp := 2;
  TransColor := 0;
  ImgNum := 0;

  GetMem(TempBuf, Image.SizeX);

  gcext.delaytime := 20;
  repeat
    B := ReadMem32B(P);
{$IFDEF Debug}
    Write(IntToStr(B));
    ReadLn;
{$ENDIF}
    P := AddPtr(P, 1);
    case B of
      $3B: Break;
      $2C:
      begin
        SetSubImage(Image, ImgNum);
{        if (image.bpp <= 8)and(image.flags or imallpal = 0)and
        (image.flags and impalette <> 0) then cnvpal :=
        ptr48(image.data,image.palstart);}
        image.time := gcext.delaytime*10;
        Inc(ImgNum);
{$IFDEF Debug}
        WriteToLog('Image block');
{$ENDIF}
        Move2(P, FarPtr(@ImageDescriptor), SizeOf(TImageDescriptor));
        P := AddPtr(P, SizeOf(TImageDescriptor));
        CurLCT := ImageDescriptor.PackedField shr 7 = 1;
        Interlaced := ImageDescriptor.PackedField shr 6 and 1 = 1;
        LCTColorSort := ImageDescriptor.PackedField shr 5 and 1 = 1;
        LCTSize := ImageDescriptor.PackedField and 7 + 1;
{$IFDEF Debug}
        WriteToLog('Check for LCT');
{$ENDIF}
        if CurLCT then
        begin
{$IFDEF Debug}
          WriteToLog('Have LCT');
{$ENDIF}
          Pal_24to32(P, cnvpal, word(1) shl LCTSize);
          if Image.BPP > 8 then
          begin
            case Image.BPP of
              15: Pal_32to15(cnvpal, CnvPal,256);
              16: Pal_32to16(cnvpal, CnvPal,256)
            end
          end
          else
            Move2(cnvpal, Ptr48(Image.Data, Image.PalStart), 1024);
          P := AddPtr(P, 3 shl LCTSize)
        end else if (image.bpp = 8)and(image.flags and impalette <> 0)and
          (image.flags and imallpal = 0) then
          Move2(farptr(mainpal), Ptr48(Image.Data, Image.PalStart), 1024);

        LZWMin := ReadMem32B(P);
{$IFDEF Debug}
        WriteToLog('Determine LZW Buf size');
{$ENDIF}
        P := AddPtr(P, 1);
        P2 := P;
        LZWSize := 0;
        repeat
          B := ReadMem32B(P2);
          Inc(LZWSize, B);
          P2 := AddPtr(P2, B + 1)
        until B = 0;

{$IFDEF Debug}
        WriteToLog('Read LZW Buf of ' + IntToStr(LZWSize) + ' bytes');
{$ENDIF}
        GetMem32(LZWData, LZWSize + 4);
        LZWPos := 0;
        repeat
          B := ReadMem32B(P);
          P := AddPtr(P, 1);
          Move2(P, Ptr48(LZWData, LZWPos), B);
          Inc(LZWPos, B);
          P := AddPtr(P, B)
        until B = 0;

{$IFDEF Debug}
        BSave32('LZW.BUF', Ptr48(LZWData, 0), LZWSize);
{$ENDIF}
        if CurLCT then
        begin
          if LZWMin < LCTSize then
            LZWMin := LCTSize
        end
        else
          if HasGCT then
            if LZWMin < GCTSize then
              LZWMin := GCTSize;
        if LZWMin > 8 then
          if CurLCT then
            LZWMin := LCTSize
          else
            LZWMin := GCTSize;

        LZWPos := 0;
        LZWBitPos := 0;
        LZWCodeS := LZWMin + 1;
        LZWCodeMask := 1 shl LZWCodeS - 1;

        X := ImageDescriptor.XP;
        Y := ImageDescriptor.YP;

        if Interlaced then IncY := 8
        else IncY := 1;

        InterPass := 0;
{$IFDEF Debug}
        WriteToLog('LZWSize: ' + IntToStr(LZWSize));
        if Interlaced then WriteToLog('Interlaced');
        WriteToLog('LZWMin: ' + IntToStr(LZWMin));
        WriteToLog('Width: ' + IntToStr(GifH.Width));
        WriteToLog('Height: ' + IntToStr(GifH.Height));
        if HasGCT then WriteToLog('GCTSize: ' + IntToStr(GCTSize));
        if CurLCT then WriteToLog('LCTSize: ' + IntToStr(LCTSize));
{$ENDIF}
        for B := 0 to 1 shl LZWMin - 1 do
        begin
          StringSuffix[B] := B;
          StringPrefix[B] := $FFFF;
          StringBegin[B] := B
        end;

        Elements := B + 3;

        CurCode := GetCode;
        if CurCode = 1 shl LZWMin then CurCode := GetCode;
        OutputStr(CurCode);

        repeat
          if Y = -1 then Break;
          if LZWPos + (LZWBitPos + LZWCodeS) shr 3 >= LZWSize then
{$IFDEF Debug}
          begin
            WriteToLog('End of LZW buffer');
            Break
          end;
{$ELSE}
            Break;
{$ENDIF}
          OldCode := CurCode;
          CurCode := GetCode;
{$IFDEF Debug}
          WriteToLog(IntToStr(CurCode));
          WriteToLog('X: ' + IntToStr(X) + ' Y: ' + IntToStr(Y));
{$ENDIF}
          if CurCode = 1 shl LZWMin then
          begin
{$IFDEF Debug}
            WriteToLog('Clear! ' + IntToStr(LZWCodeS));
{$ENDIF}
            for B := 0 to 1 shl LZWMin - 1 do
            begin
              StringSuffix[B] := B;
              StringPrefix[B] := $FFFF;
              StringBegin[B] := B
            end;

            Elements := B + 3;

            LZWCodeS := LZWMin + 1;
            LZWCodeMask := 1 shl LZWCodeS - 1;
            CurCode := GetCode;
            OutputStr(CurCode);
            Continue
          end;
          if CurCode = 1 shl LZWMin + 1 then
{$IFDEF Debug}
          begin
            WriteToLog('EOI');
            Break
          end;
{$ELSE}
            Break;
{$ENDIF}
          if CurCode < Elements then
          begin
            OutputStr(CurCode);
            if Elements < 4095 then
            begin
              StringSuffix[Elements] := StringBegin[CurCode];
              StringPrefix[Elements] := OldCode;
              StringBegin[Elements] := StringBegin[OldCode];
              Inc(Elements)
            end
          end
          else
          begin
            if CurCode > Elements then
            begin
{$IFDEF Debug}
              WriteToLog('Code too high!');
{$ENDIF}
              Error := ErrFalseFormat;
              Break
            end;
            StringSuffix[Elements] := StringBegin[OldCode];
            StringPrefix[Elements] := OldCode;
            StringBegin[Elements] := StringBegin[OldCode];
            Inc(Elements);
            OutputStr(CurCode)
          end;
          if Elements = 1 shl LZWCodeS then
          begin
            Inc(LZWCodeS);
            LZWCodeMask := 1 shl LZWCodeS - 1
          end
        until False;
        FreeMem32(LZWData)
      end;
      $21:
      begin
        B := ReadMem32B(P);
        P := AddPtr(P, 1);
        case B of
          $F9:
          begin
{$IFDEF Debug}
            WriteToLog('Ext block');
{$ENDIF}
            Move2(P, FarPtr(@GCExt), SizeOf(TGraphicControlExtension));
            CurTrans := GCExt.PackedField and 1 = 1;
            if CurTrans then IsTrans := True;
            UserInput := GCExt.PackedField and 2 = 2;
            DispMethod := GCExt.PackedField shr 2 and 7;
            P := AddPtr(P, GCExt.BlockSize + 2);
            TransColor := GCExt.TransColor
          end;
          $FE:
          repeat
{$IFDEF Debug}
            WriteToLog('Comment');
{$ENDIF}
            B := ReadMem32B(P);
            P := AddPtr(P, B + 1)
          until B = 0;
          $01:;{not supported yet}
          $FF:
          begin
{$IFDEF Debug}
            WriteToLog('App block');
{$ENDIF}
            P := AddPtr(P, 12);
            repeat
              B := ReadMem32B(P);
              P := AddPtr(P, B + 1)
            until B = 0
          end
        end
      end
    end
  until False;
{$IFDEF Debug}
  WriteToLog('End of LoadGif');
  WriteToLog('Error: ' + GetErrorString(Error));
{$ENDIF}
  FreeMem(TempBuf, Image.SizeX);

  LoadGif := Error;
  freemem(mainpal,1024);
  FreeMem32(Sel)
end;

{$UNDEF Debug}
{-$DEFINE Debug}

function SaveGif(var stream : tstream32; Image: TImage): Word;
var
{  F: File;}
  Image2: TImage;
  GifH: TGifH;
  ImageDescriptor: TImageDescriptor;
  StringSuffix: Array[0..4095] of Byte;
  StringPrefix: Array[0..4095] of Word;
  LZWData: Array[0..260] of Byte;
  LZWPos: Word;
  LZWMin: Byte;
  LZWCodeS: Byte;
  LZWBitPos: Byte;
  Elements: Word;
  X, Y, IncY: Integer;
  InterPass: Byte;
  A, B: Byte;
  CurPrefix: Word;
  CurPix: Byte;
  TmpW: Word;
  CurImg: Integer;
  Error: Integer;

  procedure PutCode(C: LongInt);
  begin
    LZWData[LZWPos] := LZWData[LZWPos] + C shl LZWBitPos;
    LZWData[LZWPos + 1] := C shl LZWBitPos shr 8;
    LZWData[LZWPos + 2] := C shl LZWBitPos shr 16;

    Inc(LZWBitPos, LZWCodeS);
    Inc(LZWPos, LZWBitPos div 8);
    LZWBitPos := LZWBitPos mod 8;
    if LZWPos >= 255 then
    begin
{$IFDEF Debug}
      WriteLn('Saving LZW table');
{$ENDIF}
      A := 255;
      stream.Write( A, 1);
      stream.Write(LZWData, 255);
      Dec(LZWPos, 255);
      Move(LZWData[255], LZWData[0], 6)
{$IFDEF Debug};
      WriteLn('LZW Table saved')
{$ENDIF}
    end
  end;

  function InputPix: Byte;
  begin
{$IFDEF Debug}
    if Image2.ImageStart + X + LongInt(Y) * Image2.BPL >= Image2.Size then
    begin
      WriteLn('Accessing: ', Image2.ImageStart + X + LongInt(Y) * Image2.BPL);
      WriteLn('ImageStart: ', Image2.ImageStart);
      WriteLn('X: ', X, ' Y: ', Y);
      WriteLn('BPL: ', Image2.BPL);
      Write('Image size: ', Image2.Size);
      ReadLn
    end;
{$ENDIF}
    InputPix := ReadMem32B(Ptr48(Image2.Data, Image2.ImageStart + X + LongInt(Y) * Image2.BPL));
    Inc(X);
    if X = Image2.SizeX then
    begin
      X := 0;
      Inc(Y, IncY)
    end;
    if Y >= Image2.SizeY then
    begin
      Inc(InterPass);
      case InterPass of
        1: Y := 4;
        2:
        begin
          Y := 2;
          IncY := 4
        end;
        3:
        begin
          Y := 1;
          IncY := 2
        end
      else
        Y := -1
      end
    end
  end;

  function SearchString(Pref: Word; Suff: Byte): Word;
  var
    W: Word;
  begin
    if Pref = $FFFF then SearchString := Suff
    else
    begin
      for W := 1 shl LZWMin + 2 to Elements do
        if (StringPrefix[W] = Pref) and (StringSuffix[W] = Suff) then Break;
      if W = Elements then SearchString := $FFFF
      else SearchString := W
    end
  end;

begin
  if Image.BPP = 8 then
  begin{
    Error := DuplicateImage(Image, Image2)}
    Image2 := Image;
{    Image2.Flags := Image2.Flags or ImLocked;}
    Error := 0
  end
  else
    Error := ConvertImage(Image, Image2, 8);
  if Error <> ErrNoError then
  begin
    SaveGif := Error;
    Exit
  end;
  SaveGif := ErrFileError;
{  Assign(F, Name);
  Rewrite(F, 1);
  if IOResult <> 0 then
  begin
    CloseImage(Image2);
    Exit
  end;}

  GifH.Sig := 'GIF';
  GifH.Ver := '87a';
  GifH.Width := Image2.SizeX;
  GifH.Height := Image2.SizeY;
  GifH.PackedField := 0;
  GifH.BGColor := 0;
  GifH.AspectRatio := 0;

  Inc(GifH.PackedField, 1 shl 7);
  Inc(GifH.PackedField, 7 shl 4);{
  Inc(GifH.PackedField, 0 shl 3);}
  Inc(GifH.PackedField, 7);

  stream.Write(GifH, SizeOf(GifH));
{$IFDEF Debug}
  WriteLn('Saving palette');
{$ENDIF}
  for B := 0 to 255 do
  begin
    A := ReadMem32B(Ptr48(Image2.Data, Image2.PalStart + B * 4 + 2));
    stream.Write(A, 1);
    A := ReadMem32B(Ptr48(Image2.Data, Image2.PalStart + B * 4 + 1));
    stream.Write(A, 1);
    A := ReadMem32B(Ptr48(Image2.Data, Image2.PalStart + B * 4 + 0));
    stream.Write(A, 1)
  end;
{$IFDEF Debug}
  WriteLn('Palette saved');
{$ENDIF}
  SaveGif := ErrNoError;
  CurImg := 0;
  repeat
    SetSubImage(Image2, CurImg);
    A := $2C;
    stream.Write(A, 1);

    ImageDescriptor.XP := 0;
    ImageDescriptor.YP := 0;
    ImageDescriptor.XS := Image2.SizeX;
    ImageDescriptor.YS := Image2.SizeY;
    ImageDescriptor.PackedField := 0;

{   Inc(ImageDescriptor.PackedField, 7 shl 7); {local color table}
{   Inc(ImageDescriptor.PackedField, 1 shl 6); {interlaced}
{   Inc(ImageDescriptor.PackedField, 1 shl 5); {color sort}
    Inc(ImageDescriptor.PackedField, 7);       {color table size}

    stream.Write(ImageDescriptor, SizeOf(ImageDescriptor));

    LZWMin := 8;
    stream.Write(LZWMin, 1);
    LZWData[0] := 0;

    FillChar(StringPrefix, SizeOf(StringPrefix), $FF);
    FillChar(StringSuffix, SizeOf(StringSuffix), 0);
    for A := 0 to 1 shl LZWMin - 1 do StringSuffix[A] := A;

    Elements := A + 3;
    LZWCodeS := LZWMin + 1;
    LZWPos := 0;
    LZWBitPos := 0;
    PutCode(1 shl LZWMin);
    CurPrefix := $FFFF;
    X := 0;
    Y := 0;
    IncY := 1;
    Interpass := 255;
    repeat
      CurPix := InputPix;
{$IFDEF Debug}
      WriteLn('X: ', X: 3, ' Y: ', Y: 3);
{$ENDIF}
      TmpW := SearchString(CurPrefix, CurPix);
      if TmpW = $FFFF then
      begin
        StringPrefix[Elements] := CurPrefix;
        StringSuffix[Elements] := CurPix;
        Inc(Elements);
        PutCode(CurPrefix);
        CurPrefix := CurPix
      end
      else CurPrefix := TmpW;
      if Elements = 4095 then
      begin
        PutCode(CurPrefix);
        PutCode(1 shl LZWMin);
        FillChar(StringPrefix, SizeOf(StringPrefix), $FF);
        FillChar(StringSuffix, SizeOf(StringSuffix), 0);
        for A := 0 to 1 shl LZWMin - 1 do StringSuffix[A] := A;
        Elements := A + 3;
        LZWCodeS := LZWMin + 1;
        CurPrefix := $FFFF;
        Continue
      end;
      if Elements = 1 shl LZWCodeS + 1 then Inc(LZWCodeS)
    until (Y >= Image2.SizeY) or (Y = -1);
    if CurPrefix <> $FFFF then
      PutCode(CurPrefix);
    PutCode(1 shl LZWMin + 1);

    if (LZWPos > 0) or (LZWBitPos > 0) then
    begin
      A := LZWPos + (LZWBitPos + 7) shr 3;
      stream.Write(A, 1);
      stream.Write(LZWData, A)
    end;
    A := 0;
    stream.Write(A, 1);
    Inc(CurImg)
  until CurImg >= Image2.NumOfImages;
  A := $3B;
  stream.Write(A, 1);

  CloseImage(Image2);

  stream.done;
end;

end.
